diff --git a/gdb/s390-linux-nat.c b/gdb/s390-linux-nat.c
index cc5e33340e..d3d98014ac 100644
--- a/gdb/s390-linux-nat.c
+++ b/gdb/s390-linux-nat.c
@@ -108,6 +108,36 @@ static const struct regset s390_64_gregset =
 #define PER_CONTROL_SUSPENSION		PER_BIT (41)
 #define PER_CONTROL_ALTERATION		PER_BIT (42)
 
+class s390_linux_nat_target final : public linux_nat_target
+{
+public:
+  /* Add our register access methods.  */
+  void fetch_registers (struct regcache *, int) override;
+  void store_registers (struct regcache *, int) override;
+
+  /* Add our watchpoint methods.  */
+  int can_use_hw_breakpoint (enum bptype, int, int) override;
+  int insert_hw_breakpoint (struct gdbarch *, struct bp_target_info *)
+    override;
+  int remove_hw_breakpoint (struct gdbarch *, struct bp_target_info *)
+    override;
+  int region_ok_for_hw_watchpoint (CORE_ADDR, int) override;
+  int have_continuable_watchpoint () { return 1; }
+  int stopped_by_watchpoint () override;
+  int watchpoint_addr_within_range (CORE_ADDR, CORE_ADDR, int) override;
+  int insert_watchpoint (CORE_ADDR, int, enum target_hw_bp_type,
+			 struct expression *) override;
+  int remove_watchpoint (CORE_ADDR, int, enum target_hw_bp_type,
+			 struct expression *) override;
+
+  /* Detect target architecture.  */
+  const struct target_desc *read_description () override;
+  int auxv_parse (gdb_byte **readptr,
+		  gdb_byte *endptr, CORE_ADDR *typep, CORE_ADDR *valp)
+    override;
+};
+
+static s390_linux_nat_target the_s390_linux_nat_target;
 
 /* Fill GDB's register array with the general-purpose register values
    in *REGP.
@@ -369,9 +399,8 @@ check_regset (int tid, int regset, int regsize)
 
 /* Fetch register REGNUM from the child process.  If REGNUM is -1, do
    this for all registers.  */
-static void
-s390_linux_fetch_inferior_registers (struct target_ops *ops,
-				     struct regcache *regcache, int regnum)
+void
+s390_linux_nat_target::fetch_registers (struct regcache *regcache, int regnum)
 {
   pid_t tid = get_ptrace_pid (regcache_get_ptid (regcache));
 
@@ -424,9 +453,8 @@ s390_linux_fetch_inferior_registers (struct target_ops *ops,
 
 /* Store register REGNUM back into the child process.  If REGNUM is
    -1, do this for all registers.  */
-static void
-s390_linux_store_inferior_registers (struct target_ops *ops,
-				     struct regcache *regcache, int regnum)
+void
+s390_linux_nat_target::store_registers (struct regcache *regcache, int regnum)
 {
   pid_t tid = get_ptrace_pid (regcache_get_ptid (regcache));
 
@@ -629,8 +657,8 @@ s390_show_debug_regs (int tid, const char *where)
 		per_info.lowcore.words.access_id);
 }
 
-static int
-s390_stopped_by_watchpoint (struct target_ops *ops)
+int
+s390_linux_nat_target::stopped_by_watchpoint ()
 {
   struct s390_debug_reg_state *state
     = s390_get_debug_reg_state (ptid_get_pid (inferior_ptid));
@@ -821,10 +849,10 @@ s390_refresh_per_info (void)
   return 0;
 }
 
-static int
-s390_insert_watchpoint (struct target_ops *self,
-			CORE_ADDR addr, int len, enum target_hw_bp_type type,
-			struct expression *cond)
+int
+s390_linux_nat_target::insert_watchpoint (CORE_ADDR addr, int len,
+					  enum target_hw_bp_type type,
+					  struct expression *cond)
 {
   s390_watch_area area;
   struct s390_debug_reg_state *state
@@ -837,10 +865,10 @@ s390_insert_watchpoint (struct target_ops *self,
   return s390_refresh_per_info ();
 }
 
-static int
-s390_remove_watchpoint (struct target_ops *self,
-			CORE_ADDR addr, int len, enum target_hw_bp_type type,
-			struct expression *cond)
+int
+s390_linux_nat_target::remove_watchpoint (CORE_ADDR addr, int len,
+					  enum target_hw_bp_type type,
+					  struct expression *cond)
 {
   unsigned ix;
   s390_watch_area *area;
@@ -865,9 +893,9 @@ s390_remove_watchpoint (struct target_ops *self,
 
 /* Implement the "can_use_hw_breakpoint" target_ops method. */
 
-static int
-s390_can_use_hw_breakpoint (struct target_ops *self,
-			    enum bptype type, int cnt, int othertype)
+int
+s390_linux_nat_target::can_use_hw_breakpoint (enum bptype type,
+					      int cnt, int othertype)
 {
   if (type == bp_hardware_watchpoint || type == bp_hardware_breakpoint)
     return 1;
@@ -876,10 +904,9 @@ s390_can_use_hw_breakpoint (struct target_ops *self,
 
 /* Implement the "insert_hw_breakpoint" target_ops method.  */
 
-static int
-s390_insert_hw_breakpoint (struct target_ops *self,
-			   struct gdbarch *gdbarch,
-			   struct bp_target_info *bp_tgt)
+int
+s390_linux_nat_target::insert_hw_breakpoint (struct gdbarch *gdbarch,
+					     struct bp_target_info *bp_tgt)
 {
   s390_watch_area area;
   struct s390_debug_reg_state *state;
@@ -894,10 +921,9 @@ s390_insert_hw_breakpoint (struct target_ops *self,
 
 /* Implement the "remove_hw_breakpoint" target_ops method.  */
 
-static int
-s390_remove_hw_breakpoint (struct target_ops *self,
-			   struct gdbarch *gdbarch,
-			   struct bp_target_info *bp_tgt)
+int
+s390_linux_nat_target::remove_hw_breakpoint (struct gdbarch *gdbarch,
+					     struct bp_target_info *bp_tgt)
 {
   unsigned ix;
   struct watch_area *area;
@@ -920,9 +946,8 @@ s390_remove_hw_breakpoint (struct target_ops *self,
   return -1;
 }
 
-static int
-s390_region_ok_for_hw_watchpoint (struct target_ops *self,
-				  CORE_ADDR addr, int cnt)
+int
+s390_linux_nat_target::region_ok_for_hw_watchpoint (CORE_ADDR addr, int cnt)
 {
   return 1;
 }
@@ -946,9 +971,10 @@ s390_target_wordsize (void)
   return wordsize;
 }
 
-static int
-s390_auxv_parse (struct target_ops *ops, gdb_byte **readptr,
-		 gdb_byte *endptr, CORE_ADDR *typep, CORE_ADDR *valp)
+int
+s390_linux_nat_target::auxv_parse (gdb_byte **readptr,
+				   gdb_byte *endptr, CORE_ADDR *typep,
+				   CORE_ADDR *valp)
 {
   int sizeof_auxv_field = s390_target_wordsize ();
   enum bfd_endian byte_order = gdbarch_byte_order (target_gdbarch ());
@@ -969,8 +995,8 @@ s390_auxv_parse (struct target_ops *ops, gdb_byte **readptr,
   return 1;
 }
 
-static const struct target_desc *
-s390_read_description (struct target_ops *ops)
+const struct target_desc *
+s390_linux_nat_target::read_description ()
 {
   int tid = s390_inferior_tid ();
 
@@ -1033,31 +1059,10 @@ s390_read_description (struct target_ops *ops)
 void
 _initialize_s390_nat (void)
 {
-  struct target_ops *t;
-
-  /* Fill in the generic GNU/Linux methods.  */
-  t = linux_target ();
-
-  /* Add our register access methods.  */
-  t->to_fetch_registers = s390_linux_fetch_inferior_registers;
-  t->to_store_registers = s390_linux_store_inferior_registers;
-
-  /* Add our watchpoint methods.  */
-  t->to_can_use_hw_breakpoint = s390_can_use_hw_breakpoint;
-  t->to_insert_hw_breakpoint = s390_insert_hw_breakpoint;
-  t->to_remove_hw_breakpoint = s390_remove_hw_breakpoint;
-  t->to_region_ok_for_hw_watchpoint = s390_region_ok_for_hw_watchpoint;
-  t->to_have_continuable_watchpoint = 1;
-  t->to_stopped_by_watchpoint = s390_stopped_by_watchpoint;
-  t->to_insert_watchpoint = s390_insert_watchpoint;
-  t->to_remove_watchpoint = s390_remove_watchpoint;
-
-  /* Detect target architecture.  */
-  t->to_read_description = s390_read_description;
-  t->to_auxv_parse = s390_auxv_parse;
+  struct target_ops *t = &the_s390_linux_nat_target;
 
   /* Register the target.  */
-  linux_nat_add_target (t);
+  add_target (t);
   linux_nat_set_new_thread (t, s390_new_thread);
   linux_nat_set_delete_thread (t, s390_delete_thread);
   linux_nat_set_prepare_to_resume (t, s390_prepare_to_resume);