diff --git a/gdb/s390-linux-nat.c b/gdb/s390-linux-nat.c
index ecb90b2422b..e77f4ac14d4 100644
--- a/gdb/s390-linux-nat.c
+++ b/gdb/s390-linux-nat.c
@@ -500,28 +500,26 @@ s390_linux_nat_target::store_registers (struct regcache *regcache, int regnum)
    The only thing we actually need is the total address space area
    spanned by the watchpoints.  */
 
-typedef struct watch_area
+struct watch_area
 {
   CORE_ADDR lo_addr;
   CORE_ADDR hi_addr;
-} s390_watch_area;
-
-DEF_VEC_O (s390_watch_area);
+};
 
 /* Hardware debug state.  */
 
 struct s390_debug_reg_state
 {
-  VEC_s390_watch_area *watch_areas;
-  VEC_s390_watch_area *break_areas;
+  std::vector<watch_area> watch_areas;
+  std::vector<watch_area> break_areas;
 };
 
 /* Per-process data.  */
 
 struct s390_process_info
 {
-  struct s390_process_info *next;
-  pid_t pid;
+  struct s390_process_info *next = nullptr;
+  pid_t pid = 0;
   struct s390_debug_reg_state state;
 };
 
@@ -547,7 +545,7 @@ s390_find_process_pid (pid_t pid)
 static struct s390_process_info *
 s390_add_process (pid_t pid)
 {
-  struct s390_process_info *proc = XCNEW (struct s390_process_info);
+  struct s390_process_info *proc = new struct s390_process_info;
 
   proc->pid = pid;
   proc->next = s390_process_list;
@@ -594,10 +592,8 @@ s390_linux_nat_target::low_forget_process (pid_t pid)
     {
       if (proc->pid == pid)
 	{
-	  VEC_free (s390_watch_area, proc->state.watch_areas);
-	  VEC_free (s390_watch_area, proc->state.break_areas);
 	  *proc_link = proc->next;
-	  xfree (proc);
+	  delete proc;
 	  return;
 	}
 
@@ -627,10 +623,8 @@ s390_linux_nat_target::low_new_fork (struct lwp_info *parent, pid_t child_pid)
   parent_state = s390_get_debug_reg_state (parent_pid);
   child_state = s390_get_debug_reg_state (child_pid);
 
-  child_state->watch_areas = VEC_copy (s390_watch_area,
-				       parent_state->watch_areas);
-  child_state->break_areas = VEC_copy (s390_watch_area,
-				       parent_state->break_areas);
+  child_state->watch_areas = parent_state->watch_areas;
+  child_state->break_areas = parent_state->break_areas;
 }
 
 /* Dump PER state.  */
@@ -676,7 +670,7 @@ s390_linux_nat_target::stopped_by_watchpoint ()
     s390_show_debug_regs (s390_inferior_tid (), "stop");
 
   /* Speed up common case.  */
-  if (VEC_empty (s390_watch_area, state->watch_areas))
+  if (state->watch_areas.empty ())
     return false;
 
   parea.len = sizeof (per_lowcore);
@@ -711,8 +705,6 @@ s390_linux_nat_target::low_prepare_to_resume (struct lwp_info *lp)
   ptrace_area parea;
 
   CORE_ADDR watch_lo_addr = (CORE_ADDR)-1, watch_hi_addr = 0;
-  unsigned ix;
-  s390_watch_area *area;
   struct arch_lwp_info *lp_priv = lwp_arch_private_info (lp);
   struct s390_debug_reg_state *state = s390_get_debug_reg_state (pid);
   int step = lwp_is_stepping (lp);
@@ -725,7 +717,7 @@ s390_linux_nat_target::low_prepare_to_resume (struct lwp_info *lp)
      hardware breakpoints (if any).  Otherwise we're done.  */
   if (!lp_priv->per_info_changed)
     {
-      if (!step || VEC_empty (s390_watch_area, state->break_areas))
+      if (!step || state->break_areas.empty ())
 	return;
     }
 
@@ -744,14 +736,12 @@ s390_linux_nat_target::low_prepare_to_resume (struct lwp_info *lp)
   memset (&per_info, 0, sizeof (per_info));
   per_info.single_step = (step != 0);
 
-  if (!VEC_empty (s390_watch_area, state->watch_areas))
+  if (!state->watch_areas.empty ())
     {
-      for (ix = 0;
-	   VEC_iterate (s390_watch_area, state->watch_areas, ix, area);
-	   ix++)
+      for (const auto &area : state->watch_areas)
 	{
-	  watch_lo_addr = std::min (watch_lo_addr, area->lo_addr);
-	  watch_hi_addr = std::max (watch_hi_addr, area->hi_addr);
+	  watch_lo_addr = std::min (watch_lo_addr, area.lo_addr);
+	  watch_hi_addr = std::max (watch_hi_addr, area.hi_addr);
 	}
 
       /* Enable storage-alteration events.  */
@@ -759,7 +749,7 @@ s390_linux_nat_target::low_prepare_to_resume (struct lwp_info *lp)
 					    | PER_CONTROL_ALTERATION);
     }
 
-  if (!VEC_empty (s390_watch_area, state->break_areas))
+  if (!state->break_areas.empty ())
     {
       /* Don't install hardware breakpoints while single-stepping, since
 	 our PER settings (e.g. the nullification bit) might then conflict
@@ -768,12 +758,10 @@ s390_linux_nat_target::low_prepare_to_resume (struct lwp_info *lp)
 	lp_priv->per_info_changed = 1;
       else
 	{
-	  for (ix = 0;
-	       VEC_iterate (s390_watch_area, state->break_areas, ix, area);
-	       ix++)
+	  for (const auto &area : state->break_areas)
 	    {
-	      watch_lo_addr = std::min (watch_lo_addr, area->lo_addr);
-	      watch_hi_addr = std::max (watch_hi_addr, area->hi_addr);
+	      watch_lo_addr = std::min (watch_lo_addr, area.lo_addr);
+	      watch_hi_addr = std::max (watch_hi_addr, area.hi_addr);
 	    }
 
 	  /* If there's just one breakpoint, enable instruction-fetching
@@ -860,13 +848,13 @@ s390_linux_nat_target::insert_watchpoint (CORE_ADDR addr, int len,
 					  enum target_hw_bp_type type,
 					  struct expression *cond)
 {
-  s390_watch_area area;
+  watch_area area;
   struct s390_debug_reg_state *state
     = s390_get_debug_reg_state (inferior_ptid.pid ());
 
   area.lo_addr = addr;
   area.hi_addr = addr + len - 1;
-  VEC_safe_push (s390_watch_area, state->watch_areas, &area);
+  state->watch_areas.push_back (area);
 
   return s390_refresh_per_info ();
 }
@@ -877,17 +865,15 @@ s390_linux_nat_target::remove_watchpoint (CORE_ADDR addr, int len,
 					  struct expression *cond)
 {
   unsigned ix;
-  s390_watch_area *area;
   struct s390_debug_reg_state *state
     = s390_get_debug_reg_state (inferior_ptid.pid ());
 
-  for (ix = 0;
-       VEC_iterate (s390_watch_area, state->watch_areas, ix, area);
-       ix++)
+  for (ix = 0; ix < state->watch_areas.size (); ix++)
     {
-      if (area->lo_addr == addr && area->hi_addr == addr + len - 1)
+      watch_area &area = state->watch_areas[ix];
+      if (area.lo_addr == addr && area.hi_addr == addr + len - 1)
 	{
-	  VEC_unordered_remove (s390_watch_area, state->watch_areas, ix);
+	  unordered_remove (state->watch_areas, ix);
 	  return s390_refresh_per_info ();
 	}
     }
@@ -914,13 +900,13 @@ int
 s390_linux_nat_target::insert_hw_breakpoint (struct gdbarch *gdbarch,
 					     struct bp_target_info *bp_tgt)
 {
-  s390_watch_area area;
+  watch_area area;
   struct s390_debug_reg_state *state;
 
   area.lo_addr = bp_tgt->placed_address = bp_tgt->reqstd_address;
   area.hi_addr = area.lo_addr;
   state = s390_get_debug_reg_state (inferior_ptid.pid ());
-  VEC_safe_push (s390_watch_area, state->break_areas, &area);
+  state->break_areas.push_back (area);
 
   return s390_refresh_per_info ();
 }
@@ -932,17 +918,15 @@ s390_linux_nat_target::remove_hw_breakpoint (struct gdbarch *gdbarch,
 					     struct bp_target_info *bp_tgt)
 {
   unsigned ix;
-  struct watch_area *area;
   struct s390_debug_reg_state *state;
 
   state = s390_get_debug_reg_state (inferior_ptid.pid ());
-  for (ix = 0;
-       VEC_iterate (s390_watch_area, state->break_areas, ix, area);
-       ix++)
+  for (ix = 0; state->break_areas.size (); ix++)
     {
-      if (area->lo_addr == bp_tgt->placed_address)
+      watch_area &area = state->break_areas[ix];
+      if (area.lo_addr == bp_tgt->placed_address)
 	{
-	  VEC_unordered_remove (s390_watch_area, state->break_areas, ix);
+	  unordered_remove (state->break_areas, ix);
 	  return s390_refresh_per_info ();
 	}
     }